def array(N1, N2=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    return [[init for i in range(N2)] for j in range(N1)]
DT=[[ 1,12, 6,15],
    [ 8,13, 3,10],
    [11, 2,16, 5],
    [14, 7, 9, 4]]
#DT=[[4,9,2],[3,5,7],[8,1,6]]
#M3=[[4,9,2],[3,5,7],[8,1,6]]
M3=[[ 1,12, 6,15],
    [ 8,13, 3,10],
    [11, 2,16, 5],
    [14, 7, 9, 4]]
def genSQR(M3,DT,setType="B"):#■MN×MN魔方陣
    NX=len(M3);NX2=NX*NX
    N=len(DT);N3=N*NX; R=array(N3,N3);N2=N*N
    for i in range(NX):
        ii=i*N
        for j in range(NX):
            jj=j*N
            for k1 in range(N):
                for k2 in range(N):
                    if setType=="A": V=(M3[i][j]-1)*N2+DT[k1][k2]
                    else:       V=M3[i][j]+(DT[k1][k2]-1)*NX2
                    R[ii+k1][jj+k2]=V
    return R
def printMat(S):#■行列の表示
    for i in range(len(S)): print(S[i])
def printSQR(RL,N):#■魔方陣の表示
    T=0            #　右上がり方向対角和表示 
    for i in range(N):T+=RL[i][N-i-1]
    S="    |%6d"% T
    print(" "*(N*6)+S,"(対角和)")
    print("   ","-"*(N*6)+"+")   #区切り表示
    for i in range(N):# 魔方陣内数字と横方向の和表示
        S="   ";T=0
        for j in range(N):
            S+="%6d"%RL[i][j]; T+=RL[i][j]
        S+=" |%6d"% T
        print(S)
    S="  "         # 縦方向の和計算と文字列変換
    for j in range(N):
        T=0
        for i in range(len(RL)):T+=RL[i][j]
        S+="%6d"% T
    T=0         #　右上がり方向対角和表示 
    for i in range(N):T+=RL[i][i]
    S+=" |%6d"% T
    print("   ","-"*(N*6)+"+\n",S, "(対角和)")
#完全魔方陣のチェック    
def cID(N,X):#■枠外ID枠内IDにする
    if   X<0: return X + N
    elif X>=N: return X - N
    return X
def checkComplete(A):
    N=len(A);TT=array(N)
    print("■右下がり方向チェック")
    
    for i in range(N):
        T=0;
        for j in range(N):T+=A[j][cID(N,i+j)]
        TT[i]=T
    print(TT)
    print("■右上がり方向チェック")
    for i in range(N):
        T=0;
        for j in range(N):T+=A[j][cID(N,i-j)]
        TT[i]=T
    print(TT)





    
print("\n■元の魔方陣 1");printSQR(M3,len(M3))
print("\n■元の魔方陣 2");printSQR(DT,len(DT))
R=genSQR(M3,DT,"A")
print("\n■生成魔方陣 生成方法 A");printSQR(R,len(R))
checkComplete(R)
R=genSQR(M3,DT,"B")
print("\n■生成魔方陣 生成方法 B");printSQR(R,len(R))
checkComplete(R)


